include:
  - template: Container-Scanning.gitlab-ci.yml
#  - template: SAST.gitlab-ci.yml
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml
#  - template: DAST.gitlab-ci.yml
  
image: docker:19.03

variables:
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: "/certs" # https://about.gitlab.com/releases/2019/07/31/docker-in-docker-with-docker-19-dot-03/
  IMAGE_TAG: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"
  DAST_WEBSITE: https://${KUBE_INGRESS_BASE_DOMAIN}/shipping/
  DAST_FULL_SCAN_ENABLED: "true"
  DAST_TARGET_AVAILABILITY_TIMEOUT: 120
  LM_JAVA_VERSION: 11
  SAST_JAVA_VERSION: 11
  ECR_REPOSITORY_IMAGE_TAG: ${ECR_REPOSITORY_BASE_URL}/${CI_PROJECT_NAME}:$CI_COMMIT_SHA

cache:
  paths:
  - .m2/repository/

stages:
- compile
- test
- docker
- deploy

Build Jar:
  stage: compile
  image: maven:3.6-jdk-11-slim
  script: mvn -DskipTests clean package
  artifacts:
    paths:
    - target/*.jar
    expire_in: 1 week

Test Jar:
  stage: test
  image: maven:3.6-jdk-11-slim
  script: mvn test
  artifacts:
    paths:
    - target/surefire-reports/TEST-*.xml
    expire_in: 1 month
    reports:
      junit: target/surefire-reports/TEST-*.xml

Build Docker Image:
  stage: docker
  services:
  - docker:19.03-dind
  cache: {} # do not download the Maven cache as it is not required
  dependencies: # to download only the Jar file but not the Surefire reports
    - Build Jar
  script:
  - apk add --no-cache curl jq python2 py-pip
  - pip install awscli

  - docker build --pull --tag=${IMAGE_TAG} -t ${ECR_REPOSITORY_IMAGE_TAG} .

  - docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}
  - docker push ${IMAGE_TAG}

  - $(aws ecr get-login --no-include-email --region eu-west-1)
  - docker push ${ECR_REPOSITORY_IMAGE_TAG}

container_scanning:
  stage: deploy
  dependencies: [] # disable download of artifacts as they are not required

.Deploy Docker Image to Dev Environment:
  stage: deploy
  image: ubuntu:18.04
  cache: {} # do not download the Maven cache as it is not required
  dependencies: [] # disable download of artifacts as they are not required
  environment: # https://stackoverflow.com/questions/44026971/gitlab-ci-kubernetes-variables-arent-set
    name: development
    url: http://${KUBE_INGRESS_BASE_DOMAIN}/shipping/
#    kubernetes:
#      namespace: catalog
  script:
  - apt-get update -q && apt-get install -y -qq curl
  - curl https://raw.githubusercontent.com/helm/helm/master/scripts/get-helm-3 | bash
  - >
    helm upgrade --install --wait --set image.tag=${IMAGE_TAG} 
    --set ci.projectPathSlug=${CI_PROJECT_PATH_SLUG}
    --set ci.environmentSlug=${CI_ENVIRONMENT_SLUG}
    --set ingress.host=${KUBE_INGRESS_BASE_DOMAIN}
    --set order.host=${ORDER_HOST}
    --set database.host=${DATABASE_HOST}
    ${CI_PROJECT_NAME} ./helm
  only:
  - master

.dast:
  stage: .post
  cache: {} # do not download the Maven cache as it is not required
  dependencies: [] # disable download of artifacts as they are not required